unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBTables, StdCtrls, SMIBase, SMI2TXT;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    DBGrid1: TDBGrid;
    SMImportFromText1: TSMImportFromText;
    btnImport: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnImportClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ShortDateFormat := 'mm/dd/yyyy';
  Table1.DatabaseName := ExtractFilePath(Application.ExeName);
  Table1.TableName := 'departs.db';
  Table1.Open;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Table1.Close
end;

procedure TForm1.btnImportClick(Sender: TObject);
begin
  SMImportFromText1.SourceFileName := ExtractFilePath(Application.ExeName) + 'departs.csv';
  SMImportFromText1.Fixed := False;

  SMImportFromText1.FieldDelimiter := fdSemicolon;
  SMImportFromText1.TextQualifier := tqNone;

  SMImportFromText1.Mappings.Clear;
  {1. convert YYYYMMDD string into MM/DD/YYYY string
   2. this MM/DD/YYYY string into date value}
  SMImportFromText1.DataFormats.CustomDateTimeFormat := 'YYYYMMDD';
  SMImportFromText1.Mappings.Add('DT=Field1');
  SMImportFromText1.Mappings.Add('ID=Field2');
  SMImportFromText1.Mappings.Add('Name=Field3');
  SMImportFromText1.Mappings.Add('Person=Field4');
//  SMImportFromText1.Mappings.Add('Person=IIF(Field1 = "", "", IIF((POS("/", Field1)>0), Field1, STRTODATE(SUBSTRING(Field1, 5, 2)+"/"+SUBSTRING(Field1, 7, 2)+"/"+SUBSTRING(Field1,1,4))))');
//  SMImportFromText1.Mappings.Add('Person=IIF((Field1="") OR (POS("/", Field1)!=0), Field3, Field2)');

  SMImportFromText1.Execute
end;

end.
