unit Main;

interface

{$IFDEF VER140}
  {$DEFINE SMForDelphi6}
{$ENDIF}

{$IFDEF VER150}
  {$DEFINE SMForDelphi6}
  {$DEFINE SMForDelphi7}
{$ENDIF}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBTables, StdCtrls, ComCtrls,
  ExtCtrls {$IFDEF SMForDelphi6} , Variants{$ENDIF}, SMIBase, SMI2TXT;

type
  TfrmMain = class(TForm)
    dSrcCountry: TDataSource;
    tblEmployee: TTable;
    smiComp: TSMImportFromText;
    pnlTop: TPanel;
    btnImport: TButton;
    btnAbout: TButton;
    DBGrid: TDBGrid;
    procedure btnImportClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}
{$R winxp.res}

procedure TfrmMain.btnImportClick(Sender: TObject);
begin
  {to define the mappings}
  smiComp.Mappings.Clear;
  smiComp.Mappings.Add('FirstName=Field1');
  smiComp.Mappings.Add('LastName=Field2');
  smiComp.Mappings.Add('SEX=SUBSTITUTE(Field3, ''M;F'', ''Male;Female'')');

  {to specify text file settings}
  smiComp.SourceFileName := ExtractFilePath(Application.ExeName) + 'emp.csv';
  smiComp.Fixed := False;
  smiComp.FieldDelimiter := fdSemicolon;
  smiComp.TextQualifier := tqQuot;
  smiComp.RecordSeparator := rsCRLF;

  {to start the import process}
  smiComp.Execute
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  tblEmployee.DatabaseName := ExtractFilePath(Application.ExeName);
  tblEmployee.Open;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  tblEmployee.Close;
end;

procedure TfrmMain.btnAboutClick(Sender: TObject);
begin
  smiComp.AboutSMI
end;

end.
